<template lang="html">
  <div class="checkbox-group">
    <h4 v-if="max" class="max-info">
      Selecionado {{selected.length}} de {{max}}
    </h4>

    <ul class="list-values" v-if="!disableAll">
      <li v-for="(item, index) in selected">
        {{returnValue(item, keylabel)}}
        <button type="button"
          class="button is-link is-small is-pulled-right"
          @click="removeItem(item)">
            remover
          </button>

      </li>
    </ul>

    <p class="control" v-for="(item, index) in checkboxes" :class='{"disabled": disabledCB || disableAll}'>
      <label>
        <input type="checkbox"
          :name="name"
          :value="item"
          v-model="selected"
          @change="removeChecked(index)"
          :disabled="disabledCB || disableAll">
        {{item.number}} - {{returnValue(item, keylabel)}}
        <span class="help-block" v-if="item[keyhelp]">{{item[keyhelp]}}</span>
      </label>
    </p>
  </div>
</template>

<script>
export default {
  name: 'checkboxgroup',
  props: {
    items: {
      required: true
    },
    keylabel: {
      type: String
    },
    keyhelp: {
      type: String
    },
    keyvalue: {
      type: String
    },
    max: {
      type: Number
    },
    name: {
      type: String,
      required: true
    },
    disableAll: {
      type: Boolean,
      default: false
    },
    defaultValue: {
      type: [String, Array]
    },
    emptyValue: {
      type: String
    }
  },
  data() {
    return {
      selected: [],
      checkboxes: [],
      disabledCB: false
    }
  },
  methods: {
    removeChecked(index) {

      this.checkboxes.splice(index, 1);
      let data = [];
      this.selected.map(item => {
        if (item.id) {
          data.push(item.id);
        } else {
          data.push(item);
        }
      })
      if (this.emptyValue && this.disableAll) {
        data.push(this.emptyValue);
      }
      this.$emit('input', data);
    },
    removeItem(item) {
      this.checkboxes.push(item);
      let idx = this.selected.indexOf(item);
      this.selected.splice(idx, 1);
    },
    returnValue(item, key) {
      if (item && item[key]) {
        return item[key];
      } else {
        return item;
      }
    },
    removeSelecteds() {
      for (let i = 0; i < this.selected.length; i++) {
        for (let j = 0; j < this.checkboxes.length; j++) {
          if (this.selected[i] == this.checkboxes[j]) {
            let index = this.checkboxes.indexOf(this.checkboxes[j]);
            this.checkboxes.splice(index, 1);
          }
        }
      }
    }
  },
  watch: {
    selected(value) {
      if (value && value.length == this.max) {
        this.disabledCB = true;
      } else {
        this.disabledCB = false;
      }
    },
    defaultValue(value) {
      if (value) {
        this.selected = [];
        value.map(item => {
          if (item.id) {
            this.selected.push(item.id);
          } else {
            this.selected.push(item);
          }
        })
        this.removeSelecteds();
      }
    },
    disableAll(value) {
      if (value && value == true) {
        this.checkboxes = this.checkboxes.concat(this.selected);
        this.selected = [];
        this.$emit('input', [this.emptyValue]);
      }
    },
    items(value) {
      if (value) {
        this.checkboxes = this.checkboxes.concat(value);
      }
    }
  },
  mounted() {
    if (this.items.length > 0) {
      this.checkboxes = this.checkboxes.concat(this.items);
    }
  }
}
</script>

<style lang="scss">
.checkbox-group {
  .list-values {
    margin: 20px 0 0 0;
    padding: 0;
    li {
      overflow: hidden;
      padding: 5px;
      &+li {
        border-top: 1px solid #ccc;
      }
    }
  }
  .two-columns {
    @media (min-width: 968px) {
      overflow: hidden;
      display: flex;
      flex-wrap: wrap;
      .checkbox {
        min-height: 36px;
        flex: 1 0 50%;
        &:first-child {
          margin-top: 0;
        }
      }
    }
    .disabler {
      display: block;
      text-align: center;
    }
  }
}
</style>
